<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.5 (révision 26263)
#									########################
#					Développé pour Thelia
#						Version : 1.5.0
#						Compatibilité plateforme : V1
#									########################
#					Développé par Lyra Network
#						http://www.lyra-network.com/
#						01/06/2011
#						Contact : support@payzen.eu
#
#####################################################################################################
/*
 * Page appelée par la plateforme de paiement pour confirmation
 */
include_once(dirname(__FILE__) . "/config.php");
include_once(dirname(__FILE__) . "/vad_api.php");

include_once("../../../classes/Commande.class.php");
include_once("../../../fonctions/divers.php");

/*
 * Initialisation des variables
 */
$vad_api = new VADS_API();
$vad_api->setResponseFromPost(
	$_REQUEST,
	MODULE_PAYMENT_VADS_KEY_TEST,
	MODULE_PAYMENT_VADS_KEY_PROD,
	MODULE_PAYMENT_VADS_CTX_MODE
);

$from_server = isset($_REQUEST['hash']);

// Urls
$url_success = urlfond("merci");
$url_error = urlfond("regret");
$url_retry = urlfond("commande");

/*
 * Vérification de l'authenticité de la requête
 */
if( ! $vad_api->isAuthentifiedResponse() )
{
	redirige($url_error);
}

// Requête authentique

/*
 * Récupération de la commande
 */
$commande = new Commande();
$reference = mysql_real_escape_string($_REQUEST['order_id']); // On n'est jamais trop prudent
$commande->charger_ref($reference);

/*
 * Action selon les différents cas
 */
if($commande->statut == 1)
{
	// Commande non payée
	if($vad_api->isAcceptedPayment())
	{
		// Paiement accepté
		$commande->statut = 2;	// statut "payé"
		$commande->genfact();	// génération facture
		$commande->maj();

		ActionsModules::instance()->appel_module("confirmation", $commande); // traitements supplémentaires

		// Message de confirmation
		if( $from_server )
		{
			// Une réponse courte pour la plateforme de paiement
			die( $vad_api->getCheckUrlResponse('payment_ok') );
		}

		// En mode test, signaler un éventuel absence d'appel à l'URL serveur.
		if( $vad_api->get('ctx_mode')=='TEST' )
		{
			echo '<html xmlns="http://www.w3.org/1999/xhtml">';
			echo '<head>';
			echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />';
			echo '</head>';

			echo '<body>';

			echo "Avertissement mode TEST : la commande a bien &eacute;t&eacute; enregistr&eacute;e, mais la validation automatique n'a pas fonctionn&eacute;.";
			echo "<br/>V&eacute;rifiez que vous avez correctement configur&eacute; l'url serveur (".MODULE_PAYMENT_VADS_URL_CHECK.") ";
			echo "dans l'outil de gestion de caisse PayZen et qu'elle est accessible depuis internet";
			echo '<br/>En mode production, vous serez redirig&eacute; automatiquement vers <a href="'.$url_success.'">la page de succ&egrave;s</a>';

			echo '</body>';
			echo '</html>';

			exit();
		}

		redirige($url_success);
	}
	else
	{
		// Paiement échoué => on laisse en non payé
		// Message de confirmation
		if( $from_server )
		{
			// Une réponse courte pour la plateforme de paiement
			die( $vad_api->getCheckUrlResponse('payment_ko') );
		}
		// Retour à la liste des moyens de paiement pour le client
		redirige($url_retry);
	}
}
else
{
	// Commande déjà payée
	if($vad_api->isAcceptedPayment())
	{
		// Paiement accepté, déjà enregistré
		if( $from_server )
		{
			// Une réponse courte pour la plateforme de paiement
			die( $vad_api->getCheckUrlResponse('payment_ok_already_done') );
		}
		// Une belle page pour le client
		redirige($url_success);
	}
	else
	{
		// Paiement échoué pour une commande déjà enregistrée (cas anormal)
		if( $from_server )
		{
			// Une réponse courte pour la plateforme de paiement
			die( $vad_api->getCheckUrlResponse('payment_ko_on_order_ok') );
		}
		// Une belle page pour le client
		redirige($url_error);
	}
}
?>