<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.5 (révision 26263)
#									########################
#					Développé pour Thelia
#						Version : 1.5.0
#						Compatibilité plateforme : V1
#									########################
#					Développé par Lyra Network
#						http://www.lyra-network.com/
#						01/06/2011
#						Contact : support@payzen.eu
#
#####################################################################################################

include_once(dirname(__FILE__) . "/../../../classes/Variable.class.php");
include_once(dirname(__FILE__) . "/config.php");

// Récupérer l'url du site
$urlsite = Variable::lire("urlsite");
$urlsite = (substr($urlsite,-1)=="/") ? $urlsite : $urlsite."/";	// lors des tests sur certaines config, urlsite n'avait pas de / à la fin

$nomsite = Variable::lire("nomsite");

$fields = array(
	array(	"name" => "MODULE_PAYMENT_VADS_URL_BANK", 					"default" => "https://secure.payzen.eu/vads-payment/",
			"label" => "Url de la page de paiement",			"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_URL_CHECK", 					"default" => $urlsite."client/plugins/payzen/confirmation.php",
			"label" => "Url serveur à renseigner dans le back office PayZen",						"type" => "fixed"),

	array(	"name" => "MODULE_PAYMENT_VADS_SITE_ID", 					"default" => "123456",
			"label" => "Identifiant de votre site",				"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_KEY_TEST", 						"default" => "1111111111111111",
			"label" => "Certificat en mode test",							"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_KEY_PROD", 						"default" => "2222222222222222",
			"label" => "Certificat en mode production",							"type" => "text"),
	/*
	array(	"name" => "MODULE_PAYMENT_VADS_LOGO", 						"default" => "logo.jpg",
			"label" => "Logo",									"type" => "fixed"),
	//*/
	/*
	array(	"name" => "MODULE_PAYMENT_VADS_LABEL", 						"default" => "PayZen",
			"label" => "Libellé",								"type" => "fixed"),
	//*/
	array(	"name" => "MODULE_PAYMENT_VADS_CTX_MODE", 					"default" => "TEST",
			"label" => "Mode de fonctionnement",				"type" => "radio",
			"options" => array("TEST", "PRODUCTION") ),

	array(	"name" => "MODULE_PAYMENT_VADS_LANG", 						"default" => "fr",
			"label" => "Langue",								"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_CURRENCY", 					"default" => "978",
			"label" => "Devise",								"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_CARDS", 						"default" => "",
			"label" => "Types de carte",						"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_PAYMENT_TYPE", 				"default" => "SINGLE",
			"label" => "Mode de paiement",						"type" => "fixed"),//TODO intégration MULTI avec thélia ??

	array(	"name" => "MODULE_PAYMENT_VADS_DELAY", 						"default" => "",
			"label" => "Délai avant remise en banque",			"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_VALIDATION_MODE", 			"default" => "",
			"label" => "Mode de validation",					"type" => "text"),
	// Paramètres de redirection
	array(	"name" => "MODULE_PAYMENT_VADS_REDIRECT_ENABLED", 			"default" => "False",
			"label" => "Redirection automatique vers la boutique à la fin du paiement",				"type" => "radio",
			"options" => array("True","False")),

	array(	"name" => "MODULE_PAYMENT_VADS_RETURN_MODE", 			"default" => "GET",
			"label" => "Mode de retour",				"type" => "select",
			"options" => array("GET","POST","NONE")),

	array(	"name" => "MODULE_PAYMENT_VADS_REDIRECT_SUCCESS_TIMEOUT", 	"default" => "5",
			"label" => "Temps avant redirection (paiement ok)",		"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_REDIRECT_SUCCESS_MESSAGE", 	"default" => "Paiement accepté, vous allez être redirigé dans quelques instants",
			"label" => "Message avant redirection (paiement ok)",	"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_REDIRECT_ERROR_TIMEOUT", 	"default" => "5",
			"label" => "Temps avant redirection (paiement échoué)",		"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_REDIRECT_ERROR_MESSAGE", 	"default" => "Un problème est survenu, vous allez être redirigé dans quelques instants",
			"label" => "Message avant redirection (paiement échoué)",		"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_URL_DEFAULT", 				"default" => $urlsite."client/plugins/payzen/confirmation.php",
			"label" => "URL de retour à la boutique",						"type" => "text"),

	array(	"name" => "MODULE_PAYMENT_VADS_CONTRIB", 					"default" => "Thelia_1.5.0",
			"label" => "Identifiant du plugin",					"type" => "fixed"),

	array(	"name" => "MODULE_PAYMENT_VADS_AUTHOR", 					"default" => '<a href="http://www.lyra-network.com/" target="_blank">Lyra network</a>',
			"label" => "Développé par",					"type" => "fixed")
);

function generate_config($input)
{
	//TODO pas dramatique (utilisateur admin) : filtrer les données du formulaire
	global $fields;

	$conf_file = realpath(dirname(__FILE__)) . "/config.php";
	$f_socket = fopen($conf_file,"w");
	if($f_socket === false)
		die("Impossible d'ouvrir le fichier $conf_file en écriture. Vérifiez que votre serveur dispose des droits nécessaires.");
	fwrite($f_socket,"<?php\n");
	fwrite($f_socket,"#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.5 (révision 26263)
#									########################
#					Développé pour Thelia
#						Version : 1.5.0
#						Compatibilité plateforme : V1
#									########################
#					Développé par Lyra Network
#						http://www.lyra-network.com/
#						01/06/2011
#						Contact : support@payzen.eu
#
#####################################################################################################");
	fwrite($f_socket,"\n");
	foreach($fields as $i => $field)
	{
		$default = defined($field['name']) ? constant($field['name']) : $field['default'];
		$value = array_key_exists($field['name'], $input) ? $input[$field['name']] : $default;
		$value = ($field['type']=='text') ? addslashes($value) : $value;
		$fields[$i]['value'] = $value; // $fields[$i] is the real thing, $field is just a copy (php foreach mechanism)
		fwrite($f_socket,"define('".$field['name']."', '".$value."');\n");
	}
	fwrite($f_socket,"?>");
}

generate_config($_POST);

// Inclusion du fichier de conf tout juste généré
include_once(realpath(dirname(__FILE__)) . "/config.php");
?>
<div id="contenu_int">
	<form action="" method="post">
	<fieldset style="margin : 5px; background-color: white;">
		<legend>Paramétrage du module de paiement PayZen</legend>
		<?php
		foreach($fields as $field)
		{
			$value = $field['value'];

			// Label
			echo '<label style="width:250px; display:block; float:left; margin-right:20px;text-align:right;">'.$field["label"].'</label>';

			// Input
			echo '<div style="display:block; float:left;">';
				switch ($field['type']) {
					case 'text':
						echo '<input type="text" name="'.$field['name'].'" value="'.$value.'" size="75"/>';
					break;

					case 'radio':
						foreach($field['options'] as $option)
						{
							echo '<input type="radio" name="'.$field['name'].'" value="'.$option.'"';
							echo ($value==$option) ? ' checked="checked"' : '';
							echo ' />';
							echo $option."&nbsp;&nbsp;";
						}
					break;

					case 'select':
						echo '<select name="'.$field['name'].'" >';
						foreach ($field['options'] as $option)
						{
							echo ($option == $value) ? '<option selected="selected">' : '<option>';
							echo $option;
							echo '</option>';
						}
						echo ' </select>';
					break;

					default:
						echo $value;
					break;
				}
			echo '</div>';

			// css clear
			echo '<div style="clear:both; height:0.5em;"></div>';
		}
		?>
		<br/>
		<input type="submit" value="Valider" />
	</fieldset>
	</form>
</div>
